import pygame

class Snake():
    def __init__(self):
        self.body = [(5,5),(5,4)]
        self.score = 0
        self.orientation = (1,0)
        self.color = (150,150,150)
        self.head_color = (170,170,170)
        self.steps = 0

    def possible_move(self, x, y):
        if (x,y) in self.body[1:]:
            return False
        return True

    def get_head(self):
        return self.body[0]

    def get_score(self):
        return self.score

    def update(self, x, y):
        self.body.insert(0, (x, y))
        self.body.pop()
        self.steps += 1
    
    def eat(self, x, y):
        self.body.insert(0, (x, y))
        self.score += 1
        self.steps = 0

    def draw(self, window, field_size):
        head = self.get_head()
        x = head[0]
        y = head[1]
        pygame.draw.rect(window, self.head_color, (x * field_size, y * field_size, field_size, field_size))
        for (x,y) in self.body[1:]:
            pygame.draw.rect(window, self.color, (x * field_size, y * field_size, field_size, field_size))

    def set_orientation(self, x, y):
        self.orientation = (x, y)

    def set_new_orientation(self, nn_output):
        if(nn_output[0] > 0.5):
            self.set_orientation(0, -1)
        elif (nn_output[1] > 0.5):
            self.set_orientation(0, 1)
        elif (nn_output[2] > 0.5):
            self.set_orientation(-1, 0)
        elif (nn_output[3] > 0.5):
            self.set_orientation(1, 0)